<template>
  <a-spin :spinning="confirmLoading">
    <j-form-container :disabled="formDisabled">
      <a-form-model ref="form" :model="model" :rules="validatorRules" slot="detail">
        <a-row>
          <a-col :span="24">
            <a-form-model-item label="所属类型" :labelCol="labelCol" :wrapperCol="wrapperCol" prop="typeId">
              <a-input v-model="model.typeId" placeholder="请输入大纲ID"  v-show='false'></a-input>
              <a-input :value="model.typeName"   disabled></a-input>
            </a-form-model-item>
          </a-col>
          <a-col :span="24">
            <a-form-model-item label="编号" :labelCol="labelCol" :wrapperCol="wrapperCol" prop="num">
              <a-input-number v-model="model.num" placeholder="请输入编号" style="width: 100%" />
            </a-form-model-item>
          </a-col>
          <a-col :span="24">
            <a-form-model-item label="编码" :labelCol="labelCol" :wrapperCol="wrapperCol" prop="code">
              <a-input v-model="model.code" placeholder="请输入编码"  ></a-input>
            </a-form-model-item>
          </a-col>
          <a-col :span="24">
            <a-form-model-item label="名称" :labelCol="labelCol" :wrapperCol="wrapperCol" prop="name">
              <a-input v-model="model.name" placeholder="请输入名称"  ></a-input>
            </a-form-model-item>
          </a-col>
<!--          <a-col :span="24">
            <a-form-model-item label="别名" :labelCol="labelCol" :wrapperCol="wrapperCol" prop="alias">
              <a-input v-model="model.alias" placeholder="请输入别名"  ></a-input>
            </a-form-model-item>
          </a-col>
          <a-col :span="24">
            <a-form-model-item label="测试说明" :labelCol="labelCol" :wrapperCol="wrapperCol" prop="explain">
              <a-textarea  v-model="model.description" placeholder="请输入测试说明"  :auto-size="{ minRows: 5, maxRows: 20 }" ></a-textarea>
            </a-form-model-item>
          </a-col>
          <a-col :span="24">
            <a-form-model-item label="测试方法" :labelCol="labelCol" :wrapperCol="wrapperCol" prop="method">
              <a-textarea v-model="model.method" placeholder="请输入测试方法"   :auto-size="{ minRows: 5, maxRows: 20 }"></a-textarea>
            </a-form-model-item>
          </a-col>
          <a-col :span="24">
            <a-form-model-item label="技术指标" :labelCol="labelCol" :wrapperCol="wrapperCol" prop="techIndex">
              <a-textarea v-model="model.techIndex" placeholder="请输入技术指标"   :auto-size="{ minRows: 3, maxRows: 20 }"></a-textarea>
            </a-form-model-item>
          </a-col>
          <a-col :span="24">
            <a-form-model-item label="运算方法" :labelCol="labelCol" :wrapperCol="wrapperCol" prop="operational">
              <a-input v-model="model.operational" placeholder="请输入运算方法"  ></a-input>
            </a-form-model-item>
          </a-col>
          <a-col :span="24">
            <a-form-model-item label="产品类型" :labelCol="labelCol" :wrapperCol="wrapperCol" prop="prodType">
              <a-input v-model="model.prodType" placeholder="请输入产品类型"  ></a-input>
            </a-form-model-item>
          </a-col>   -->
          <a-col :span="24">
            <a-form-model-item label="排序" :labelCol="labelCol" :wrapperCol="wrapperCol" prop="sort">
              <a-input-number v-model="model.sort" placeholder="请输入排序" style="width: 100%" />
            </a-form-model-item>
          </a-col>
          <a-col :span="24">
            <a-form-model-item label="是否常规项" :labelCol="labelCol" :wrapperCol="wrapperCol" prop="gengeral">
              <j-switch   v-model='model.gengeral'></j-switch>
            </a-form-model-item>
          </a-col>
<!--          <a-col :span="24">
            <a-form-model-item label='关联仪器' :labelCol='labelCol' :wrapperCol='wrapperCol' prop='insturment'>
              <a-select v-model="model.instrument"   placeholder='请选择关联仪器'>
                <a-select-option v-for="ins in instruments" :key="ins.id">
                  {{ ins.name }}
                </a-select-option>
              </a-select>
            </a-form-model-item>
          </a-col>-->
          <a-col :span="24">
            <a-form-model-item label="启用标志" :labelCol="labelCol" :wrapperCol="wrapperCol" prop="enabled">
              <j-switch   v-model='model.enabled'></j-switch>
            </a-form-model-item>
          </a-col>
<!--          <a-col :span="24">
            <a-form-model-item label="状态" :labelCol="labelCol" :wrapperCol="wrapperCol" prop="status">
              <a-input v-model="model.status" placeholder="请输入状态"  ></a-input>
            </a-form-model-item>
          </a-col>
          <a-col :span="24">
            <a-form-model-item label="备注" :labelCol="labelCol" :wrapperCol="wrapperCol" prop="remark">
              <a-input v-model="model.remark" placeholder="请输入备注"  ></a-input>
            </a-form-model-item>
          </a-col>-->
        </a-row>
      </a-form-model>
    </j-form-container>
  </a-spin>
</template>

<script>

import { httpAction, getAction, deleteAction } from '@/api/manage'
  import { validateDuplicateValue } from '@/utils/util'

  export default {
    name: 'LimsTestingItemForm',
    components: {
    },
    props: {
      //表单禁用
      disabled: {
        type: Boolean,
        default: false,
        required: false
      }
    },
    data () {
      return {
        model:{
         },
        parent:{
        },

        //仪器列表
        instruments:[],
        labelCol: {
          xs: { span: 24 },
          sm: { span: 5 },
        },
        wrapperCol: {
          xs: { span: 24 },
          sm: { span: 16 },
        },
        confirmLoading: false,
        validatorRules: {
          code: [{ required: true, message: '鉴定项目编号不能为空', trigger: 'blur' }],
          name: [{ required: true, message: '鉴定项目名称不能为空', trigger: 'blur' }],
          sort: [{ required: true, message: '鉴定项目排序不能为空', trigger: 'blur' }],
          enabled: [{ required: true, message: '鉴定项目启用状态不能为空', trigger: 'blur' }]
        },
        url: {
          add: "/lims/testing/item/add",
          edit: "/lims/testing/item/edit",
          del: '/lims/testing/item/delete',
          queryById: "/lims/testing/item/queryById",
          insturmentList: '/limsInstrument/list'
        }
      }
    },
    computed: {
      formDisabled(){
        return this.disabled
      },
    },
    created () {
       //备份model原始值
      this.modelDefault = JSON.parse(JSON.stringify(this.model));
    },
    methods: {
      add () {
        this.edit(this.modelDefault);
      },
      edit (record) {
        this.model = Object.assign({}, record);
        this.visible = true;
      },
      setData(parent,model){
        this.parent = parent;
        this.model = model
        this.model.enabled = 1
        this.model.typeId = parent.typeId
        this.model.typeName = parent.typeName

        //如果存在id 查询数据
        if(this.model.id){
          this.queryItmById(this.model.id,parent)
        }
        this.queryInstrumentList()

      },

      del(id){
        deleteAction(this.url.del,{id:id}).then(res=>{
          if(res.success){
            this.$message.success('操作成功!')
            this.$emit('ok');
          }else {
            this.$message.error('操作失败!')
          }
        })
      },
      queryItmById(id,parent){
        getAction(this.url.queryById,{id:id}).then(res=>{
          console.info(res)
          if(res.success){
            this.model = Object.assign(res.result, parent);

            console.info(this.model)
          }

        })

      },
      /**
       * 查询仪器列表
       */
      queryInstrumentList() {
        getAction(this.url.insturmentList).then(res => {
          if (res.success) {
            this.instruments = res.result.records
          }
        })

      },
      submitForm () {
        const that = this;
        // 触发表单验证
        this.$refs.form.validate(valid => {
          if (valid) {
            that.confirmLoading = true;
            let httpurl = '';
            let method = '';
            if(!this.model.id){
              httpurl+=this.url.add;
              method = 'post';
            }else{
              httpurl+=this.url.edit;
               method = 'put';
            }
            httpAction(httpurl,this.model,method).then((res)=>{
              if(res.success){
                that.$message.success(res.message);
                that.$emit('ok');
              }else{
                that.$message.warning(res.message);
              }
            }).finally(() => {
              that.confirmLoading = false;
            })
          }

        })
      },
      resetForm(){
        this.model ={typeId:this.parent.typeId,typeName:this.parent.typeName}
      }
    }
  }
</script>